//busqueda de camins entre 2 vertexos + Dijkstra
#include "headers.h"
#include <iostream>
#include <fstream> 
#include <vector>
#include <string>
//troba la posici dels supervrtexs
void FindPositionSupervertices(supervertices &W, vertices &V){
	int n=W.size();
	int m=V.size();

	for(int i=0; i<n; i++){
		for(int j=0; j<W[i].salientes.size(); j++){
			index aux=FindPositionSuperVertex(W, W[i].salientes[j]);
			W[i].salirsuper.push_back(aux);
		}
		for(int k=0; k<W[i].entrantes.size(); k++){
			index aux=FindPositionSuperVertex(W, W[i].entrantes[k]);
			W[i].entrarsuper.push_back(aux);
		}
	}
}
//buscar la posici en el supervrtex
index FindPositionSuperVertex(supervertices &W, index v){//yo tengo vertices v y quiero encontrar position en W
	for(int i=0; i<W.size();i++)
		if(W[i].vertice==v)
				return i;
return -1;
}
//imprimir camins minimis
void printPath(supervertices W,vertices V, vector<index> parents, string namefile, int *dsvtv,index sv, index tv){
	vector<index> pares;
	index v=tv;
	pares.push_back(v);
	while(v!=sv){
		pares.push_back(parents[v]);
		v=parents[v];
	}
	
	ofstream fout;
	fout.open(namefile);

	for(int i=pares.size()-1; i>=0; i--)
		fout<<" "<<pares[i];
	fout<<endl;
	for(int i=pares.size()-1; i>=0; i--){
		index w=W[pares[i]].vertice;
		fout<<"Autopista: "<<V[w].highway1<<" , creuament: "<<V[w].namecrossroad<<endl;
	}
	fout.close();
}
//trobar la ruta minim entre v1,v2
vector<index> findFastestRoad(vertex v1, vertex v2, vertices V, autopistas A, supervertices W, int *dsvtv){
	//Trobar camins desde A fins a B
	vector<index> Z;//solucio del cami ms curt
	vector<index> T;
	index InicioAutopista;
	index FinalAutopista;
	InicioAutopista=findVertexFromSuperEdges(v1,V,W,A,1);
	FinalAutopista=findVertexFromSuperEdges(v2,V,W,A,2);

	//ahora tendriamos q hacer un dijkstra desde inicioAutopista hasta FinalAutopista.
	Z=DijkstraPath(W, InicioAutopista, FinalAutopista, dsvtv,"DijkstraPath.txt");

	//ahora tenemos en Z el camino mas corto de los supervertices, encontrar T que es el camino mas corto de vertices
	if(InicioAutopista!=Z[0]){
		int numeroautopista=findHighwayWith2Vertex(InicioAutopista, Z[0], A);
		if(numeroautopista==-1){
			cout<<"Tenemos un problema con el tramo "<<InicioAutopista<<" - "<<Z[0]<<endl;exit;}
		vector<index> aux=ConectarVertexASupervertex(InicioAutopista,Z[0],A[numeroautopista]);
		for(int i=0; i<aux.size(); i++)
			T.push_back(aux[i]);
	}
	for(int i=0; i<Z.size() -1; i++){
		if(Z[i]!=Z[i+1]){
			int numeroautopista=findHighwayWith2Vertex(Z[i], Z[i+1], A);
			if(numeroautopista==-1){
			cout<<"Tenemos un problema con el tramo "<<Z[i]<<" - "<<Z[i+1]<<endl;exit;}
			vector<index> aux=ConectarVertexASupervertex(Z[i], Z[i+1],A[numeroautopista]);
			for(int j=0; j<aux.size();j++)
				T.push_back(aux[j]);
		}
	}
	if(Z[Z.size()-1]!=FinalAutopista){
		int numeroautopista=findHighwayWith2Vertex(Z[Z.size()-1], FinalAutopista, A);
		if(numeroautopista==-1){
			cout<<"Tenemos un problema con el tramo "<<Z[Z.size()-1]<<" - "<<FinalAutopista<<endl;exit;}
		vector<index> aux=ConectarVertexASupervertex(Z[Z.size()-1],FinalAutopista, A[numeroautopista]);
		for(int i=0; i<aux.size();i++)
			T.push_back(aux[i]);
	}
return T;
}
//trobar l'autopista amb dos vertexs
int findHighwayWith2Vertex(index inicio, index final, autopistas A){
	//esta funcion nos busca la posicion de la autopista que buscamos con dos vertices
	int position=-1;
	vector<int> High(A.size(), 0);

	for(int i=0; i<A.size(); i++)
		for(int j=0; j<A[i].namecross.size(); j++)
			if(A[i].namecross[j]==inicio || A[i].namecross[j]==final)
				High[i]++;
		
	for(int i=0; i<High.size(); i++)
		if(High[i]==2){
			position=i;break;}
return position;
}
//trobar vertex a partir de superArcs
index findVertexFromSuperEdges(vertex v,vertices V, supervertices W, autopistas A, int iniciofinal){
		//primer o mirar si el vertex v es supervertex.
	int autop=-1; int super=-1;
	for(int i=0; i<W.size(); i++)
		if(v.identificadorVertex==W[i].vertice)
			return v.identificadorVertex;
	//ahora sabemos que no es un supervertex, entonces solo estara en una autopista y no 2
	for(int i=0; i<A.size(); i++)
		for(int j=0; j<A[i].namecross.size(); j++)
			if(A[i].namecross[j]==v.identificadorVertex){
				autop=i; super=j;
				break;
			}
		//aqui conozco la posicion del vertice, dependiendo de si es inicio o final buscare un vertice o otro.
		//si iniciofinal=1, es el inicio, buscar siguiente supervertice
		if(iniciofinal==1){
			for(int i=super; i<A[autop].namecross.size(); i++)
				if(MirarSiVerticePerteneceASupervertices(V[A[autop].namecross[i]], W)==true)
					return V[A[autop].namecross[i]].identificadorVertex;
				
		}
		if(iniciofinal==2){
			for(int i=super; i>=0; i--)
				if(MirarSiVerticePerteneceASupervertices(V[A[autop].namecross[i]], W)==true)
					return V[A[autop].namecross[i]].identificadorVertex;
		}
}
//conectar el vertex al seu corresponent supervertex
vector<index> ConectarVertexASupervertex(index start, index end, autopista a){
	int positioninicial, positionfinal;
	vector<index> guardarvertex;

	for(int i=0; i<a.namecross.size(); i++){
		if(a.namecross[i]==start) 
			positioninicial=i;
		if(a.namecross[i]==end)
			positionfinal=i;
	}
	for(int i=positioninicial; i<=positionfinal; i++)
			guardarvertex.push_back(a.namecross[i]);
	
return guardarvertex;
}


//troba el cami minim de Dijkstra, retorna la llista dels pares
vector<index> DijkstraPath(supervertices W, index sv, index tv, int *dsvtv,string filename){
	//sv es la posicion del primer vertice, tv la posicion del ultimo
	 index vn = W.size();
	 int infty = UINT_MAX;

	 for (index v = 0; v<vn; v++)
		 for (index i = 0; i<W[v].t2.size(); i++)
			 infty+=W[v].t2[i];

	 ofstream fout;
	 fout.open(filename);
	 
	 vector<int> Dd(vn, infty);
	 Dd[sv] = 0;
	 vector<bool> Dl(vn, false);
	 vector<index> Dp(vn, vn);	
	 Dp[sv] = sv;
	 int mdv = sv;
	 do {
		 Dl[mdv] = true;
		 for (index i = 0; i<W[mdv].salirsuper.size(); i++) //es desplegar 
			if(Dd[W[mdv].salirsuper[i]]>Dd[mdv]+W[mdv].t2[i]){
				Dd[W[mdv].salirsuper[i]]=Dd[mdv]+W[mdv].t2[i];
				Dp[W[mdv].salirsuper[i]]=mdv;
			 }
		 int md = infty;
		 mdv = vn;
		 for (int v = 0; v<vn; v++)
			 if(md>Dd[v] && !Dl[v]){
					md = Dd[v];
					mdv = v;
			}
	 } while (mdv != vn  && mdv != tv );//mdv=vn es q no ha legado a tv nunca
	 if(mdv==vn)
		 cout<<"No se puede conectar el primer punto con el ultimo\n";
	 *dsvtv = infty;
	 if( mdv == tv ) {
		fout << "Dijkstra path\n";
		index pv = tv;
		fout << pv;
		while ( pv!=sv ) {
			pv = Dp[pv];
			fout << " <- " << pv;
		}
		fout<<endl;
	}
	*dsvtv = Dd[tv];
	 fout << endl;
	 fout.close();
	 
	 return Dp;
 }