//Tot allo relacionat amb tram saturats, col.lapsats...
#include "headers.h"
#include <iostream>
#include <fstream> 
#include <vector>
#include <string>
//mirar si el vertex es un supervrtex
void FindRoad_Highway(vertices &V, autopistas A){
	int numberHighways=A.size();

	ofstream fe;
	fe.open("Vertices2Highway.txt");

	fe<<"Crossing of two highways, supervertexs are:"<<endl;
	
	for(int i=0; i<V.size(); i++){
		V[i].road=true;
		for(int j=0; j<numberHighways; j++)
				if(A[j].namehighway.compare(V[i].namecrossroad)==0){
						V[i].road=false;
						fe<<"highway "<<V[i].highway1<<" with "<< V[i].namecrossroad<<" \n";
						break;
				}
	}
	fe.close();
}
//mira trams saturats i imprimeix i retorna trams hipersaturats
vector<index> PrintTrafficJam(vertices V, arcs E, string filename){
	double velocity=0;
	double tiempo=0;
	double delta=0;
	double flux=0;
	int n1=0,n2=0,n3=0,n4=0,n5=0,n6=0,n7=0,n8=0;

	vector<index> normal;
	vector<index> sat1;
	vector<index> hipersat;

	ofstream fe;
	fe.open(filename);

	for(index i=0; i<E.size(); i++){
		if(E[i].FluxAfterCross<=2020*E[i].numberlanes)
			normal.push_back(i);
		else if(E[i].FluxAfterCross>2020*E[i].numberlanes && E[i].FluxAfterCross<=2770*E[i].numberlanes)
			sat1.push_back(i);
		else
		hipersat.push_back(i);
	}
	//aqui ya tenemos los tramos separados por la seguritat
	fe<<"Per a la seguretat alta, alfa=0.5 tenim els trams seguents:"<<endl;
	for(index i=0; i<normal.size(); i++){
		delta=0;
		flux=E[normal[i]].CarsPerLane;
		delta=(0.425-(3600/flux))*(0.425-(3600/flux))-1.8403;
		velocity=((3600/flux)-0.425+sqrt(delta))/0.1296;		
		tiempo=1000*E[normal[i]].lengthsection/velocity;
		fe<<" Autopista "<<E[normal[i]].highway<< " desde cross "<<E[normal[i]].fromcross<<" fins cross "<<E[normal[i]].tocross<<" amb una velocitat de "<<3.6*velocity<< "km/h i tarda "<<tiempo<<"segons."<<endl;
		if(velocity<=(30/3.6))
			n1++;
		else if(velocity>(30/3.6)&& velocity<=(60/3.6))
			n2++;
		else if(velocity>(60/3.6) && velocity<=(90/3.6))
			n3++;
		else if(velocity>(90/3.6))
			n4++;
	}
	fe<<endl;
	fe<<endl;
	fe<<"Per a la seguretat intermitja, alfa=0.3 tenim els trams seguents:"<<endl;
	velocity=0; flux=0;tiempo=0;delta=0;
	for(index i=0; i<sat1.size(); i++){
		flux=E[sat1[i]].CarsPerLane;
		delta=(0.255-(3600/flux))*(0.255-(3600/flux))-1.104;
		velocity=((3600/flux)-0.255-sqrt(delta))/0.0777605;
		tiempo=1000*E[sat1[i]].lengthsection/velocity;
		fe<<" Autopista "<<E[sat1[i]].highway<< " desde cross "<<E[sat1[i]].fromcross<<" fins cross "<<E[sat1[i]].tocross<<" amb una velocitat de "<<3.6*velocity<< "km/h i tarda "<<tiempo<<"segons."<<endl;
		if(velocity<=(30/3.6))
			n5++;
		else if(velocity>(30/3.6)&& velocity<=(60/3.6))
			n6++;
		else if(velocity>(60/3.6) && velocity<=(90/3.6))
			n7++;
		else if(velocity>(90/3.6))
			n8++;
	}
	fe<<endl; fe<<endl;

	fe<<"Trams hipersaturats, formacio de cua, alfa=0.3:"<<endl;
	for(index i=0; i<hipersat.size(); i++){//aqui cogeremos velocidad=48.7km/h
		velocity=0; tiempo=0;
		velocity=48.7/3.6;
		tiempo=2*1000*E[hipersat[i]].lengthsection/velocity;
		fe<<" Autopista "<<E[hipersat[i]].highway<< " desde cross "<<E[hipersat[i]].fromcross<<" hasta cross "<<E[hipersat[i]].tocross<<" i tarda "<<tiempo<<"segons."<<endl;
	}
	fe<<endl;
	fe<<"Tenim "<<normal.size()<<" no saturats alfa=0.5, "<<sat1.size()<<" trams no saturats alfa=0.3 i "<<hipersat.size()<<" hipersaturats"<<endl;
	fe<<"I "<<E.size()<<" trams totals"<<endl;
	fe<<"Per alfa=0.5 tenim "<<n1<< " trams entre 0,30; "<<n2<<" trams entre 30,60; "<<n3<<" trams entre 60,90; "<<n4<<" trams entre 90,vmax"<<endl;
	fe<<"Per alfa=0.3 tenim "<<n5<< " trams entre 0,30; "<<n6<<" trams entre 30,60; "<<n7<<" trams entre 60,90; "<<n8<<" trams entre 90,vmax"<<endl;
	fe<<endl;

	fe.close();
return hipersat;
}
//calcula la longitud de tots els trams hipersaturats en km
double DistanciaColapsada(arcs E, vector <index> colapse){
	double l=0;
	for(int i=0; i<colapse.size(); i++)
		l+=E[colapse[i]].lengthsection;
return l;
}